Coin: SoToVRML2Action Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | List of all members
SoToVRML2Action Class Reference
Action Classes

The SoToVRML2Action class builds a new scene graph, using only VRML97/VRML2 nodes. More...

`#include <Inventor/actions/SoToVRML2Action.h>`

Inheritance diagram for SoToVRML2Action:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoToVRML2Action (void)
virtual | ~SoToVRML2Action (void)
virtual void | apply (SoNode *node)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
class SoVRMLGroup * | getVRML2SceneGraph (void) const
void | reuseAppearanceNodes (SbBool appearance)
SbBool | doReuseAppearanceNodes (void) const
void | reusePropertyNodes (SbBool property)
SbBool | doReusePropertyNodes (void) const
void | reuseGeometryNodes (SbBool geometry)
SbBool | doReuseGeometryNodes (void) const
Public Member Functions inherited from SoToVRMLAction
| SoToVRMLAction (void)
virtual | ~SoToVRMLAction (void)
SoNode * | getVRMLSceneGraph (void) const
void | expandSoFile (SbBool flag)
SbBool | areSoFileExpanded (void) const
void | setUrlName (const SbString name)
SbString | getUrlName (void) const
void | writeTexCoords (SbBool flag)
SbBool | areTexCoordWritten (void) const
void | expandTexture2Node (SbBool flag)
SbBool | areTexture2NodeExpanded (void) const
void | keepUnknownNodes (SbBool flag)
SbBool | areUnknownNodeKept (void) const
void | convertInlineNodes (SbBool flag)
SbBool | doConvertInlineNodes (void) const
void | conditionalConversion (SbBool flag)
SbBool | doConditionalConversion (void) const
void | setVerbosity (SbBool flag)
SbBool | isVerbose (void) const
Public Member Functions inherited from SoAction
virtual | ~SoAction (void)
virtual SbBool | isOfType (SoType type) const
void | apply (SoAction *beingApplied)
virtual void | invalidateState (void)
AppliedCode | getWhatAppliedTo (void) const
SoNode * | getNodeAppliedTo (void) const
SoPath * | getPathAppliedTo (void) const
const SoPathList * | getPathListAppliedTo (void) const
const SoPathList * | getOriginalPathListAppliedTo (void) const
SbBool | isLastPathListAppliedTo (void) const
PathCode | getPathCode (int &numindices, const int *&indices)
void | traverse (SoNode *const node)
SbBool | hasTerminated (void) const
const SoPath * | getCurPath (void)
SoState * | getState (void) const
PathCode | getCurPathCode (void) const
virtual SoNode * | getCurPathTail (void)
void | usePathCode (int &numindices, const int *&indices)
void | pushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (const PathCode prevpathcode)
void | pushCurPath (void)
void | popPushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (void)
void | switchToPathTraversal (SoPath *path)
void | switchToNodeTraversal (SoNode *node)

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoToVRMLAction
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoAction
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static void | nullAction (SoAction *action, SoNode *node)

## Protected Member Functions
virtual const SoEnabledElementsList & | getEnabledElements (void) const
virtual void | beginTraversal (SoNode *node)
Protected Member Functions inherited from SoToVRMLAction
Protected Member Functions inherited from SoAction
| SoAction (void)
virtual void | endTraversal (SoNode *node)
void | setTerminated (const SbBool flag)
virtual SbBool | shouldCompactPathList (void) const

## Static Protected Member Functions
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoToVRMLAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)

## Additional Inherited Members
Public Types inherited from SoAction
enum | AppliedCode { NODE = 0 , PATH = 1 , PATH_LIST = 2 }
enum | PathCode { NO_PATH = 0 , IN_PATH = 1 , BELOW_PATH = 2 , OFF_PATH = 3 }
Protected Attributes inherited from SoAction
SoState * | state
SoActionMethodList * | traversalMethods

## Detailed Description

The SoToVRML2Action class builds a new scene graph, using only VRML97/VRML2 nodes.

This action is used for converting a scene graph of VRML1/Coin nodes to a new scene graph using only VRML97/VRML2 nodes.

Due to the basic differences between VRML1/Coin and VRML2 (the latter does not really have a traversal state) the new scene graph will typically be somewhat larger. To minimize this effect the action tries to reuse nodes when possible.

VRML1 nodes will be converted to their equivalent VRML2 nodes, while Coin nodes with no VRML2 equivalent are converted to IndexedFaceSet. If the DrawStyle is POINTS, all geometry will be built using PointSet; if it is LINES IndexedLineSet is used.

Here's a basic usage example of this action, in the form of a complete, standalone program:

#include <Inventor/SoDB.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoOutput.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/actions/SoToVRML2Action.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/VRMLnodes/SoVRMLGroup.h>
int
main(int argc, char *argv[])
{
SoDB::init();
SoInteraction::init();
SoInput in;
in.openFile(argv[1]);
printf("Reading...\n");
SoSeparator *root = SoDB::readAll(&in);
if (root) {
root->ref();
SbString hdr = in.getHeader();
in.closeFile();
printf("Converting...\n");
SoToVRML2Action tovrml2;
tovrml2.apply(root);
SoVRMLGroup *newroot = tovrml2.getVRML2SceneGraph();
newroot->ref();
root->unref();
printf("Writing...\n");
SoOutput out;
out.openFile("out.wrl");
out.setHeaderString("#VRML V2.0 utf8");
SoWriteAction wra(&out);
wra.apply(newroot);
out.closeFile();
newroot->unref();
}
return 0;
}
SbString
The SbString class is a string class with convenience functions for string operations.
Definition SbString.h:52
SoBase::unref
void unref(void) const
Definition SoBase.cpp:530
SoBase::ref
void ref(void) const
Definition SoBase.cpp:478
SoDB::readAll
static SoSeparator * readAll(SoInput *input)
Definition SoDB.cpp:682
SoDB::init
static void init(void)
Definition SoDB.cpp:200
SoInput
The SoInput class is an abstraction of file import functionality.
Definition SoInput.h:61
SoInput::closeFile
virtual void closeFile(void)
Definition SoInput.cpp:580
SoInput::getHeader
virtual SbString getHeader(void)
Definition SoInput.cpp:778
SoInput::openFile
virtual SbBool openFile(const char *fileName, SbBool okIfNotFound=FALSE)
Definition SoInput.cpp:495
SoInteraction::init
static void init(void)
Definition SoInteraction.cpp:127
SoOutput
The SoOutput class is an abstraction of an output stream.
Definition SoOutput.h:51
SoOutput::openFile
virtual SbBool openFile(const char *const fileName)
Definition SoOutput.cpp:413
SoOutput::closeFile
virtual void closeFile(void)
Definition SoOutput.cpp:439
SoOutput::setHeaderString
virtual void setHeaderString(const SbString &str)
Definition SoOutput.cpp:674
SoSeparator
The SoSeparator class is a state-preserving group node.
Definition SoSeparator.h:44
SoToVRML2Action
The SoToVRML2Action class builds a new scene graph, using only VRML97/VRML2 nodes.
Definition SoToVRML2Action.h:40
SoToVRML2Action::apply
virtual void apply(SoNode *node)
Definition SoToVRML2Action.cpp:635
SoToVRML2Action::getVRML2SceneGraph
class SoVRMLGroup * getVRML2SceneGraph(void) const
Definition SoToVRML2Action.cpp:665
SoVRMLGroup
The SoVRMLGroup class is used for grouping VRML nodes.
Definition SoVRMLGroup.h:45
SoWriteAction
The SoWriteAction class writes a scene graph to file.
Definition SoWriteAction.h:42

Note: if VRML97 support is not present in the Coin library, this action does nothing and getVRML2SceneGraph always returns `NULL`.

See also
  SoToVRMLAction

Since
  Coin 2.0
  TGS Inventor 2.5

## Constructor & Destructor Documentation

## ◆ SoToVRML2Action()

SoToVRML2Action::SoToVRML2Action | ( | void |  | ) |

Constructor.

## ◆ ~SoToVRML2Action()

SoToVRML2Action::~SoToVRML2Action | ( | void |  | ) |
| virtual

The destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoToVRML2Action::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and "downward" casting.

Reimplemented from SoToVRMLAction.

## ◆ getClassTypeId()

SoType SoToVRML2Action::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ addMethod()

void SoToVRML2Action::addMethod | ( | const SoType | type,
|  | SoActionMethod | method )
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ enableElement()

void SoToVRML2Action::enableElement | ( | const SoType | type,
|  | const int | stackindex )
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ getEnabledElements()

const SoEnabledElementsList & SoToVRML2Action::getEnabledElements | ( | void |  | ) | const
| protectedvirtual

Returns list of enabled elements.

Reimplemented from SoToVRMLAction.

## ◆ getClassEnabledElements()

SoEnabledElementsList * SoToVRML2Action::getClassEnabledElements | ( | void |  | ) |
| staticprotected

Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ getClassActionMethods()

SoActionMethodList * SoToVRML2Action::getClassActionMethods | ( | void |  | ) |
| staticprotected

Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ initClass()

void SoToVRML2Action::initClass | ( | void |  | ) |
| static

Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

## ◆ apply() [1/3]

void SoToVRML2Action::apply | ( | SoNode * | root | ) |
| virtual

Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoToVRMLAction.

## ◆ apply() [2/3]

void SoToVRML2Action::apply | ( | SoPath * | path | ) |
| virtual

Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoToVRMLAction.

## ◆ apply() [3/3]

void SoToVRML2Action::apply | ( | const SoPathList & | pathlist,
|  | SbBool | obeysrules = FALSE )
| virtual

Applies action to the graphs defined by pathlist. If obeysrules is set to `TRUE`, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
  SoAction::apply(SoPath * path)

Reimplemented from SoToVRMLAction.

## ◆ getVRML2SceneGraph()

SoVRMLGroup * SoToVRML2Action::getVRML2SceneGraph | ( | void |  | ) | const

Return a pointer to the root node of the generated scene graph of only VRML2 / VRML97 nodes.

Will return `NULL` if VRML97 support was not compiled into the library.

## ◆ reuseAppearanceNodes()

void SoToVRML2Action::reuseAppearanceNodes | ( | SbBool | appearance | ) |

Set the flag deciding if appearance nodes should be reused if possible. The default is FALSE.

Please note that support for reusing Appearance nodes is not implemented yet.

## ◆ doReuseAppearanceNodes()

SbBool SoToVRML2Action::doReuseAppearanceNodes | ( | void |  | ) | const

Get the flag deciding if appearance nodes should be reused if possible. The default is FALSE.

Please note that support for reusing Appearance nodes is not implemented yet, so this method will always return FALSE.

## ◆ reusePropertyNodes()

void SoToVRML2Action::reusePropertyNodes | ( | SbBool | property | ) |

Set the flag deciding if property nodes should be reused if possible. The default is FALSE.

## ◆ doReusePropertyNodes()

SbBool SoToVRML2Action::doReusePropertyNodes | ( | void |  | ) | const

Get the flag deciding if property nodes should be reused if possible. The default is FALSE.

## ◆ reuseGeometryNodes()

void SoToVRML2Action::reuseGeometryNodes | ( | SbBool | geometry | ) |

Set the flag deciding if geometry nodes should be reused if possible. The default is FALSE.

Please note that support for reusing Geometry nodes is not implemented yet.

## ◆ doReuseGeometryNodes()

SbBool SoToVRML2Action::doReuseGeometryNodes | ( | void |  | ) | const

Get the flag deciding if geometry nodes should be reused if possible. The default is FALSE.

Please note that support for reusing Geometry nodes is not implemented yet, so this function will always return FALSE.

## ◆ beginTraversal()

void SoToVRML2Action::beginTraversal | ( | SoNode * | node | ) |
| protectedvirtual

This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoToVRMLAction.

The documentation for this class was generated from the following files:

- SoToVRML2Action.h
- SoToVRML2Action.cpp